<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="月份" prop="month">
        <el-select v-model="queryParams.month" placeholder="请选择月份" clearable>
          <el-option label="01" value="01"></el-option>
          <el-option label="02" value="02"></el-option>
          <el-option label="03" value="03"></el-option>
          <el-option label="04" value="04"></el-option>
          <el-option label="05" value="05"></el-option>
          <el-option label="06" value="06"></el-option>
          <el-option label="07" value="07"></el-option>
          <el-option label="08" value="08"></el-option>
          <el-option label="09" value="09"></el-option>
          <el-option label="10" value="10"></el-option>
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item> -->
      <el-form-item label="州市" prop="cityCode">
        <el-select
          v-model="queryParams.cityCode"
          placeholder="请选择州市"
          clearable
        >
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
          />
        </el-select>
      </el-form-item>
      <el-form-item style="margin-left: 25px;">
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
        <el-button type="primary"  size="mini" @click="handleExport"
          >导出列表</el-button
        >
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table
        v-loading="loading"
        :data="rzgHighValuePatentInfoList"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <el-table-column label="排序" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{ scope.row["ranking"] }}</span>
          </template>
        </el-table-column>

        <el-table-column label="地区" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{ scope.row["cityName"] }}</span>
          </template>
        </el-table-column>

        <el-table-column :label="hearderTitle" align="center">
          <el-table-column label="战略性新兴产业" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["industryEmergIndustry"] }}</span>
            </template>
          </el-table-column>

          <el-table-column label="	维持年限超10年" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["maintenanceTenYear"] }}</span>
            </template>
          </el-table-column>

          <el-table-column label="在海外有同族专利" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["overseasCongenerPatent"] }}</span>
            </template>
          </el-table-column>

          <el-table-column label="存在质押记录" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["pledgeRecord"] }}</span>
            </template>
          </el-table-column>
          <el-table-column label="获得国家科技奖或者中国专利奖" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["nationalScienceAward"] }}</span>
            </template>
          </el-table-column>
          <el-table-column label="高价值发明专利有效量合计" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["effectiveTotal"] }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="hearderTitle2" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["yearPopulation"] }}</span>
            </template>
          </el-table-column>
          <el-table-column
            label="每万人高价值发明专利拥有量（件/万人）"
            align="center"
          >
            <template slot-scope="scope">
              <span>{{ scope.row["hvPatentThousands"] }}</span>
            </template>
          </el-table-column>
          <el-table-column label="同比增长" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["growth"] }}</span>
            </template>
          </el-table-column>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
import {
  listRzgHighValuePatentInfo,
  getRzgHighValuePatentInfo,
  delRzgHighValuePatentInfo,
  addRzgHighValuePatentInfo,
  updateRzgHighValuePatentInfo,
  getYearList,
  getRegionList,
} from "@/api/highval/rzgHighValuePatentInfo";

export default {
  name: "RzgHighValuePatentInfo",
  data() {
    return {

      hearderTitle: "统计时期",
      hearderTitle2: '年人口',
      maxHeight: 0,
      // 查询年份数据
      yearList: [],
      regionOptions: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 高价值专利-万人高价值专利统计表格数据
      rzgHighValuePatentInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 100,
        cityCode: null,
        cityName: null,
        year: "2022",
        month: "",
        sort: null,
        industryEmergIndustry: null,
        overseasCongenerPatent: null,
        maintenanceTenYear: null,
        pledgeRecord: null,
        nationalScienceAward: null,
        effectiveTotal: null,
        yearPopulation: null,
        highValuePatentOwner: null,
        growth: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getHearderTitle();
    this.getYear();
    this.getList();
    this.getRegion();
    this.$nextTick(() => {
      this.maxHeight = window.innerHeight - 200; //300是页面中除了表格外其他组件的高度
    });
  },
  methods: {
    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then((response) => {
        this.regionOptions = response.data;
      });
    },
    /** 获取查询年份列表 */
    getYear() {
      getYearList().then((response) => {
        this.yearList = response.data;
      });
    },

    getHearderTitle(){
      let title='统计时期';
      let popu='人口（万人）';
      if(this.queryParams.year){
        title=title+'-'+this.queryParams.year;
        popu=this.queryParams.year+'年'+popu;
      }
      this.hearderTitle2=popu;
      this.hearderTitle=title;

    },


    handerMethod({ row, column, rowIndex, columnIndex }) {
      // if (rowIndex === 0) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         this.$nextTick(() => {
      //             var _c = document.getElementsByClassName(column.id);
      //             document.getElementsByClassName(column.id)[0].setAttribute('rowSpan', 2);
      //         });
      //         return column;
      //     }
      // } else if (rowIndex === 1) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         return { display: 'none' };
      //     }
      // }
      // if (column[0].level == 1) {
      //     column[0].rowSpan = 2
      //     column[1].rowSpan = 0
      //     if (rowIndex === 1) {
      //         return { display: 'none' }
      //     }
      // }
    },

    /** 查询高价值专利-万人高价值专利统计列表 */
    getList() {
      this.loading = true;
      listRzgHighValuePatentInfo(this.queryParams).then((response) => {
        this.rzgHighValuePatentInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        sort: null,
        industryEmergIndustry: null,
        overseasCongenerPatent: null,
        maintenanceTenYear: null,
        pledgeRecord: null,
        nationalScienceAward: null,
        effectiveTotal: null,
        yearPopulation: null,
        highValuePatentOwner: null,
        growth: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getHearderTitle();

      if (this.queryParams.year) {
        this.queryParams.pageNum = 1;
        this.getList();
      } else {
        this.$message("请选择年份");
      }


    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加高价值专利-万人高价值专利统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getRzgHighValuePatentInfo(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改高价值专利-万人高价值专利统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateRzgHighValuePatentInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzgHighValuePatentInfo(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm(
          '是否确认删除高价值专利-万人高价值专利统计编号为"' +
            ids +
            '"的数据项？'
        )
        .then(function () {
          return delRzgHighValuePatentInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "highval/rzgHighValuePatentInfo/export",
        {
          ...this.queryParams,
        },
        `rzgHighValuePatentInfo_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
